<script setup>
import { storeToRefs } from "pinia";
import BaseButton from "@/components/BaseButton.vue";
import { useInfoStore } from "@/stores/Info";
import { useSessionStore } from "@/stores/Session";
import { useConnectionStore } from "@/stores/Connection";
import StatusBar from "@/components/StatusBar.vue";

const connectionStore = useConnectionStore();
const infoStore = useInfoStore();
const sessionStore = useSessionStore();

sessionStore.bindEvents();

const { joinSession, leaveSession, revealSession, castVote } = sessionStore;

const {
  sessionId: session,
  sessionUrl,
  moderator,
  moderatorName,
  castedVotes,
  joining,
  deckValues,
  selected,
  votableGuests,
  voting,
  revealed,
  metrics,
} = storeToRefs(sessionStore);
const { nickname } = storeToRefs(infoStore);

const props = defineProps({
  sessionId: {
    type: String,
    required: true,
  },
});

session.value = props.sessionId;
joinSession();
</script>

<template>
  <div class="container">
    <StatusBar />
    <div class="row">
      <div class="col d-flex flex-column text-center mt-5">
        <div class="h4">
          Session:
          <div>
            <span class="h6 fw-bold text-decoration-none user-select-all">
              {{ sessionUrl }}
            </span>
          </div>
        </div>
      </div>
    </div>
    <template v-if="connectionStore.connecting">
      <div class="row justify-content-center">
        <div class="col-12 col-sm-10 col-md-6">
          <div class="d-flex justify-content-center align-items-center">
            <div class="spinner-border me-2" role="status">
              <span class="visually-hidden">Loading...</span>
            </div>
            <div class="display-6">Connecting...</div>
          </div>
        </div>
      </div>
    </template>
    <template v-else-if="joining">
      <div class="row justify-content-center">
        <div class="col-12 col-sm-10 col-md-6">
          <div class="d-flex justify-content-center align-items-center">
            <div class="spinner-border me-2" role="status">
              <span class="visually-hidden">Loading...</span>
            </div>
            <div class="display-6">Joining...</div>
          </div>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="row justify-content-center">
        <div class="col-12 col-sm-10 col-md-8 col-lg-6">
          <div class="card">
            <div class="card-body">
              <div class="d-flex justify-content-between align-items-center">
                <h5 class="card-title">Session Info</h5>
                <div>
                  <BaseButton variant="outline-danger" @click="leaveSession">
                    Leave
                  </BaseButton>
                </div>
              </div>
              <h6 class="card-subtitle mb-2 text-body-secondary">
                <span class="fw-bold">ID:</span>&nbsp;
                <span class="user-select-all">{{ session }}</span>
              </h6>
              <h6 class="card-subtitle mb-2 text-body-secondary">
                <span class="fw-bold">Moderator:</span>
                {{ moderator ? "You!" : moderatorName }}
              </h6>
              <h6 class="card-subtitle mb-2 text-body-secondary">
                <span class="fw-bold">Votes:</span> {{ castedVotes || 0 }} /
                {{ votableGuests || 0 }}
              </h6>
            </div>
          </div>
          <div class="display-6 text-center">
            Welcome <span class="fw-bold">{{ nickname }}</span
            >!
          </div>
        </div>
      </div>
      <template v-if="!moderator">
        <div class="row my-2">
          <div class="col d-grid gap-2 d-sm-flex justify-content-sm-between">
            <BaseButton variant="warning" @click="selected = null">
              Clear
            </BaseButton>
            <BaseButton
              variant="success"
              :loading="voting"
              :disabled="selected === null"
              @click="castVote"
            >
              Vote
            </BaseButton>
          </div>
        </div>
        <div
          class="row row-cols-1 row-cols-sm-3 row-cols-md-4 g-3 g-md-4 g-lg-5 my-1"
        >
          <div v-for="value in deckValues" :key="value" class="col">
            <div
              class="card option-card"
              :class="{ 'border-warning border-3': selected === value }"
              @click="selected = value"
            >
              <div class="card-body d-flex justify-content-center">
                <h5 class="card-title display-5">{{ value }}</h5>
              </div>
            </div>
          </div>
        </div>
      </template>
      <template v-else>
        <div class="row my-2">
          <div class="col d-grid d-sm-flex justify-content-sm-end">
            <BaseButton variant="outline-primary" @click="revealSession">
              Reveal Votes
            </BaseButton>
          </div>
        </div>
        <template v-if="revealed">
          <div class="row justify-content-center mb-4">
            <div class="col-12 col-sm-10 col-md-8 col-lg-6 col-xl-4">
              <div class="card">
                <div class="card-body">
                  <h5 class="card-title">Overall</h5>
                  <div class="card-text">
                    <ul class="list-group h3">
                      <li
                        class="list-group-item d-flex justify-content-between align-items-center"
                      >
                        <div>Min</div>
                        <div>
                          {{ metrics.min }}
                        </div>
                      </li>
                      <li
                        class="list-group-item d-flex justify-content-between align-items-center"
                      >
                        <div>Max</div>
                        <div>
                          {{ metrics.max }}
                        </div>
                      </li>
                      <li
                        class="list-group-item d-flex justify-content-between align-items-center"
                      >
                        <div>Mode</div>
                        <div>
                          {{ metrics.mode.join(",") }}
                        </div>
                      </li>
                    </ul>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div
            class="row row-cols-1 row-cols-sm-2 row-cols-lg-4 row-cols-xl-5 g-2"
          >
            <div v-for="(vote, i) in metrics.itemized" :key="i" class="col">
              <div class="card-group">
                <div class="card">
                  <div class="card-body text-center">
                    <h5 class="card-title display-4">{{ vote }}</h5>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </template>
      </template>
    </template>
  </div>
</template>

<style scoped>
.option-card {
  -webkit-transition: transform 0.1s ease-in-out;
  transition: transform 0.1s ease-in-out;
  cursor: pointer;
}
.option-card:hover {
  transform: scale(1.2);
}
</style>
